package com.mysql.jdbc;

import java.rmi.server.UID;
import java.sql.SQLException;
import java.sql.Savepoint;

/* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/MysqlSavepoint.class */
public class MysqlSavepoint implements Savepoint {
    private String savepointName;

    private static String getUniqueId() {
        String uidStr = new UID().toString();
        int uidLength = uidStr.length();
        StringBuffer safeString = new StringBuffer(uidLength);
        for (int i = 0; i < uidLength; i++) {
            char c = uidStr.charAt(i);
            if (Character.isLetter(c) || Character.isDigit(c)) {
                safeString.append(c);
            } else {
                safeString.append('_');
            }
        }
        return safeString.toString();
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public MysqlSavepoint() throws SQLException {
        this(getUniqueId());
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public MysqlSavepoint(String name) throws SQLException {
        if (name == null || name.length() == 0) {
            throw SQLError.createSQLException("Savepoint name can not be NULL or empty", SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.savepointName = name;
    }

    @Override // java.sql.Savepoint
    public int getSavepointId() throws SQLException {
        throw SQLError.createSQLException("Only named savepoints are supported.", SQLError.SQL_STATE_DRIVER_NOT_CAPABLE);
    }

    @Override // java.sql.Savepoint
    public String getSavepointName() throws SQLException {
        return this.savepointName;
    }
}
